n_per = policylength/granularity;

LB = [0.0*ones(1,n_per) -3.0*ones(1,n_per) ...
      -3.0*ones(1,n_per) 0.0*ones(1,n_per)];
UB = 3.0*ones(1,4*n_per);

% Optimizer settings
opts_fsolve=optimoptions('fsolve','Display','off',...
                         'TolFun',1e-9,'UseParallel',false,...
                         'MaxFunctionEvaluations',100000,...
                         'MaxIterations',1000);

opts_fmincon=optimoptions('fmincon','Display','iter','TolFun',mintol,...
                          'MaxFunctionEvaluations',1000000,...,
                          'OptimalityTolerance',mintol,...
                          'MaxIterations',maxiter,...,
                          'UseParallel',true);

% opts_fmincon=optimoptions('fmincon','Display','iter','TolFun',1e-7,...
%                           'MaxFunctionEvaluations',1000000,...,
%                           'OptimalityTolerance',mintol,...
%                           'MaxIterations',10000,...,
%                           'UseParallel',true,...
%                           'FiniteDifferenceStepSize',1e-3);

% starting point for model solution comes from init_guess
n_vec_guess = [lrss*ones(2*HH,1);...
    xrss*deltaHss*ones(1*HH,1);xrss*deltaFss*ones(1*HH,1);...
    xrss*deltaHss*ones(1*HH,1);xrss*deltaFss*ones(1*HH,1);...
    1*ones(HH,1)];

muh = zeros(HH,1);
muf = zeros(HH,1);
muhstar = zeros(HH,1);
mufstar = zeros(HH,1);

muh(1:policylength) = kron(init_guess(1:n_per),ones(1,granularity));
muf(1:policylength) = kron(init_guess((n_per+1):(2*n_per)),ones(1,granularity));
muhstar(1:policylength) = kron(init_guess((2*n_per+1):(3*n_per)),ones(1,granularity));
mufstar(1:policylength) = kron(init_guess((3*n_per+1):(4*n_per)),ones(1,granularity));

n_vec_guess=fsolve(@getErr,n_vec_guess,opts_fsolve,HH,policylength,beta,z,zstar,kappa,alpha,sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,Uiss,Urss,Udeath,muh,muf,muhstar,mufstar,delta_muin,delta_nuin);

mu_guess = init_guess;

% get number of policy decisions for each country
n_pol = size(mu_guess,2)/2;

homesol = mu_guess(1:n_pol);
forsol = mu_guess(n_pol+1:end);

% initialize looping
sse = 100;
iter = 1;

while (iter < maxiter & sse > nashsse)
    
    iter
    
    inhomesol = homesol;
    inforsol = forsol;
    
    % function that takes home taxes as given. Returns foreign Welfare
    getUstarnash = @(fortaxesin) getU([homesol fortaxesin],...
                                      n_vec_guess,opts_fsolve,...
                                      HH,policylength,granularity,beta,z,zstar,...
                                      kappa,alpha,sigma,I0,Istar0,pop0,popstar0,...
                                      pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,...
                                      Uiss,Urss,Udeath,delta_muin,delta_nuin,...
                                      2);

    forsol = fmincon(getUstarnash,forsol,...
                     [],[],[],[],LB(n_pol+1:end),UB(n_pol+1:end),[],...
                     opts_fmincon);

    % function that takes foreign taxes as given. Returns home Welfare
    getUnash = @(hometaxesin) getU([hometaxesin forsol],...
                                   n_vec_guess,opts_fsolve,...
                                   HH,policylength,granularity,beta,z,zstar,...
                                   kappa,alpha,sigma,I0,Istar0,pop0,popstar0,...
                                   pi1,pi2,pi3,pi4,pir,pid,pid_accel,phi,...
                                   Uiss,Urss,Udeath,delta_muin,delta_nuin,...
                                   1);

    homesol = fmincon(getUnash,homesol,...
                      [],[],[],[],LB(1:n_pol),UB(1:n_pol),[],...
                      opts_fmincon);
    
    err = [homesol forsol] - [inhomesol inforsol];    
    
    sse = sqrt(sum(err.^2))
    
    iter = iter + 1;
end

optimalpolicy = [homesol forsol];

% get the equilbrium solution
muh = zeros(HH,1);
muf = zeros(HH,1);
muhstar = zeros(HH,1);
mufstar = zeros(HH,1);

muh(1:policylength) = kron(optimalpolicy(1:n_per),ones(1,granularity));
muf(1:policylength) = kron(optimalpolicy((n_per+1):(2*n_per)),ones(1,granularity));
muhstar(1:policylength) = kron(optimalpolicy((2*n_per+1):(3*n_per)),ones(1,granularity));
mufstar(1:policylength) = kron(optimalpolicy((3*n_per+1):(4*n_per)),ones(1,granularity));

Model_Solution;

save(savefile)
